/*
import 'dart:async';
import 'package:rxdart/rxdart.dart';

typedef Subscribe<T> = void Function();

abstract class Observer<T> {
  void onData(T value);
  void onError();
  void onDone();
  bool cancelOnError();
}

class ReactiveCommandBase<T> extends Stream<T> {
  ReactiveCommandBase(
      [Stream<bool> canExecuteSource, bool initialValue = true]) {
    if (canExecuteSource == null) canExecuteSource = Rx.never();
    _canExecute = initialValue;
    canExecuteSubscription = canExecuteSource.distinct().listen((event) {
      _canExecute = event;
    });
  }

  Subject<T> _trigger = BehaviorSubject<T>();
  StreamSubscription<bool> canExecuteSubscription;

  bool _canExecute = true;
  bool get canExecute => _canExecute;

  bool _isClosed = false;
  bool get isClosed => _isClosed;

  bool get isBroadcast => true;

  StreamSubscription<T> listen(void onData(T value),
      {Function onError, void onDone(), bool cancelOnError}) {
    return _trigger.listen(onData,
        onError: onError, onDone: onDone, cancelOnError: cancelOnError);
  }

  void add(T parameter) {
    if (canExecute) _trigger.add(parameter);
  }

  void close() {
    if (isClosed) return;
    _isClosed = true;
    _canExecute = false;
    _trigger.close();
    canExecuteSubscription.cancel();
  }
}

class ReactiveCommand<T> extends ReactiveCommandBase<void> {
  ReactiveCommand([Stream<bool> canExecuteSource, bool initialValue = true])
      : super(canExecuteSource, initialValue);

  List<Subscribe> subscriptions = [];

  void execute() {
    if (canExecute) subscriptions.forEach((onNext) => onNext());
  }

  void call() => execute();

  void subscribe(Subscribe onNext) {
    subscriptions.add(onNext);
  }
}

extension RxCommandExtension on Stream<bool> {
  ReactiveCommand toReactiveCommand<T>(bool initialState) {
    return ReactiveCommand<T>(this, initialState);
  }
}*/

/*

typedef Subscribe<T> = void Function();
class ReactiveCommandOld extends Reactive<bool> {
  ReactiveCommandOld() : super(true);

  final subscribes = <Subscribe>[];

  static ReactiveProperty<T> replay<T>(T initalValue) {
    return ReplayReactiveProperty(initalValue);
  }

  void subscribe(Subscribe sub) {
    subscribes.add(sub);
  }

  void execute() {
    if (value) {
      subscribes.forEach((sub) => sub());
    }
  }

  factory ReactiveCommandOld.async() {
    return ReactiveCommandAsync();
  }

  call() => execute();

  static ReactiveProperty<T> publish<T>(T initalValue) {
    return PublishReactiveProperty(initalValue);
  }
}

class ReactiveCommandAsync extends ReactiveCommandOld {
  @override
  set value(value) => super.value = value;

  final subscribes = <Subscribe>[];

  @override
  add(bool value) => super.add;

  static ReactiveProperty<T> replay<T>(T initalValue) {
    return ReplayReactiveProperty(initalValue);
  }

  void subscribe(Subscribe sub) {
    subscribes.add(sub);
  }

  Future<void> execute() async {
    if (value) {
      await subscribes.forEach((sub) async {
        await sub();
      });
    }
  }

  call() => execute();

  static ReactiveProperty<T> publish<T>(T initalValue) {
    return PublishReactiveProperty(initalValue);
  }
}

typedef SubscribeParam<T> = void Function(T param);

class ReactiveCommandParam<T> extends Reactive<bool> {
  ReactiveCommandParam() : super(true);
  @override
  set value(value) => super.value = value;

  final subscribes = <SubscribeParam<T>>[];

  @override
  add(bool value) => super.add;

  void subscribe(SubscribeParam<T> sub) {
    subscribes.add(sub);
  }

  void execute(T param) {
    if (value) {
      subscribes.forEach((sub) => sub(param));
    }
  }

  call(T param) => execute(param);
}
*/
